CfnAddon L1 construct
Creates an Amazon EKS add-on.
Amazon EKS add-ons help to automate the provisioning and lifecycle management of common operational software for Amazon EKS clusters. For more information, see Amazon EKS add-ons in the Amazon EKS User Guide .
Example
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_eks as eks } from 'aws-cdk-lib';
const cfnAddon = new eks.CfnAddon(this, 'MyCfnAddon', {
addonName: 'addonName',
clusterName: 'clusterName',
// the properties below are optional
addonVersion: 'addonVersion',
configurationValues: 'configurationValues',
namespaceConfig: {
namespace: 'namespace',
},
podIdentityAssociations: [{
roleArn: 'roleArn',
serviceAccount: 'serviceAccount',
}],
preserveOnDelete: false,
resolveConflicts: 'resolveConflicts',
serviceAccountRoleArn: 'serviceAccountRoleArn',
tags: [{
key: 'key',
value: 'value',
}],
});
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_eks as eks
cfn_addon = eks.CfnAddon(self, "MyCfnAddon",
addon_name="addonName",
cluster_name="clusterName",
# the properties below are optional
addon_version="addonVersion",
configuration_values="configurationValues",
namespace_config=eks.CfnAddon.NamespaceConfigProperty(
namespace="namespace"
),
pod_identity_associations=[eks.CfnAddon.PodIdentityAssociationProperty(
role_arn="roleArn",
service_account="serviceAccount"
)],
preserve_on_delete=False,
resolve_conflicts="resolveConflicts",
service_account_role_arn="serviceAccountRoleArn",
tags=[CfnTag(
key="key",
value="value"
)]
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.eks.*;
CfnAddon cfnAddon = CfnAddon.Builder.create(this, "MyCfnAddon")
.addonName("addonName")
.clusterName("clusterName")
// the properties below are optional
.addonVersion("addonVersion")
.configurationValues("configurationValues")
.namespaceConfig(NamespaceConfigProperty.builder()
.namespace("namespace")
.build())
.podIdentityAssociations(List.of(PodIdentityAssociationProperty.builder()
.roleArn("roleArn")
.serviceAccount("serviceAccount")
.build()))
.preserveOnDelete(false)
.resolveConflicts("resolveConflicts")
.serviceAccountRoleArn("serviceAccountRoleArn")
.tags(List.of(CfnTag.builder()
.key("key")
.value("value")
.build()))
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.EKS;
var cfnAddon = new CfnAddon(this, "MyCfnAddon", new CfnAddonProps {
AddonName = "addonName",
ClusterName = "clusterName",
// the properties below are optional
AddonVersion = "addonVersion",
ConfigurationValues = "configurationValues",
NamespaceConfig = new NamespaceConfigProperty {
Namespace = "namespace"
},
PodIdentityAssociations = new [] { new PodIdentityAssociationProperty {
RoleArn = "roleArn",
ServiceAccount = "serviceAccount"
} },
PreserveOnDelete = false,
ResolveConflicts = "resolveConflicts",
ServiceAccountRoleArn = "serviceAccountRoleArn",
Tags = new [] { new CfnTag {
Key = "key",
Value = "value"
} }
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"
cfnAddon := awscdk.Aws_eks.NewCfnAddon(this, jsii.String("MyCfnAddon"), &CfnAddonProps{
AddonName: jsii.String("addonName"),
ClusterName: jsii.String("clusterName"),
// the properties below are optional
AddonVersion: jsii.String("addonVersion"),
ConfigurationValues: jsii.String("configurationValues"),
NamespaceConfig: &NamespaceConfigProperty{
Namespace: jsii.String("namespace"),
},
PodIdentityAssociations: []interface{}{
&PodIdentityAssociationProperty{
RoleArn: jsii.String("roleArn"),
ServiceAccount: jsii.String("serviceAccount"),
},
},
PreserveOnDelete: jsii.Boolean(false),
ResolveConflicts: jsii.String("resolveConflicts"),
ServiceAccountRoleArn: jsii.String("serviceAccountRoleArn"),
Tags: []CfnTag{
&CfnTag{
Key: jsii.String("key"),
Value: jsii.String("value"),
},
},
})
Initializer
new CfnAddon(scope: Construct, id: string, props: CfnAddonProps)
CfnAddon(scope: Construct, id: str, props: CfnAddonProps)
new CfnAddon(Construct scope, String id, CfnAddonProps props)
new CfnAddon(Construct scope, string id, CfnAddonProps props)
NewCfnAddon(Scope Construct, Id *string, Props CfnAddonProps)
Construct Props
addonVersionoptionalstringaddon_versionoptionalstraddonVersionoptionalStringAddonVersionoptionalstringAddonVersionoptional*string#configurationValuesoptionalstringconfiguration_valuesoptionalstrconfigurationValuesoptionalStringConfigurationValuesoptionalstringConfigurationValuesoptional*string#namespaceConfigoptionalIResolvable | CfnAddon.NamespaceConfigPropertynamespace_configoptionaltyping.Union[IResolvable, NamespaceConfigProperty]namespaceConfigoptionalIResolvableNamespaceConfigoptionalIResolvableNamespaceConfigoptionalinterface{}#This specifies the Kubernetes namespace where the addon is installed.
podIdentityAssociationsoptionalIResolvable | IResolvable | CfnAddon.PodIdentityAssociationProperty[]pod_identity_associationsoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, PodIdentityAssociationProperty]]]podIdentityAssociationsoptionalIResolvablePodIdentityAssociationsoptionalIResolvablePodIdentityAssociationsoptionalinterface{}#notes
Each association maps a role to a service account in a namespace in the cluster.
For more information, see Attach an IAM Role to an Amazon EKS add-on using EKS Pod Identity in the Amazon EKS User Guide .
preserveOnDeleteoptionalboolean | IResolvablepreserve_on_deleteoptionaltyping.Union[bool, IResolvable]preserveOnDeleteoptionalBooleanPreserveOnDeleteoptionalboolPreserveOnDeleteoptionalinterface{}#If an IAM account is associated with the add-on, it isn't removed.
resolveConflictsoptionalstringresolve_conflictsoptionalstrresolveConflictsoptionalStringResolveConflictsoptionalstringResolveConflictsoptional*string#notes
Conflicts are handled based on the value you choose:
- None – If the self-managed version of the add-on is installed on your cluster, Amazon EKS doesn't change the value. Creation of the add-on might fail.
- Overwrite – If the self-managed version of the add-on is installed on your cluster and the Amazon EKS default value is different than the existing value, Amazon EKS changes the value to the Amazon EKS default value.
- Preserve – This is similar to the NONE option. If the self-managed version of the add-on is installed on your cluster Amazon EKS doesn't change the add-on resource properties. Creation of the add-on might fail if conflicts are detected. This option works differently during the update operation. For more information, see
UpdateAddon.
If you don't currently have the self-managed version of the add-on installed on your cluster, the Amazon EKS add-on is installed. Amazon EKS sets all values to default values, regardless of the option that you specify.
serviceAccountRoleArnoptionalstring | IRoleRefservice_account_role_arnoptionaltyping.Union[str, IRoleRef]serviceAccountRoleArnoptionalStringServiceAccountRoleArnoptionalstringServiceAccountRoleArnoptionalinterface{}#notes
The role must be assigned the IAM permissions required by the add-on. If you don't specify an existing IAM role, then the add-on uses the permissions assigned to the node IAM role. For more information, see Amazon EKS node IAM role in the Amazon EKS User Guide .
To specify an existing IAM role, you must have an IAM OpenID Connect (OIDC) provider created for your cluster. For more information, see Enabling IAM roles for service accounts on your cluster in the Amazon EKS User Guide .
tagsoptionalCfnTag[]tagsoptionaltyping.List[CfnTag]tagsoptionalList<CfnTag>TagsoptionalCfnTag[]Tagsoptional*[]CfnTag#Each tag consists of a key and an optional value, both of which you define. Add-on tags do not propagate to any other resources associated with the cluster.
Properties
addonRefAddonReferenceaddon_refAddonReferenceaddonRefAddonReferenceAddonRefAddonReferenceAddonRefAddonReferencerequired#addonVersionmay be undefinedstringaddon_versionmay be undefinedstraddonVersionmay be undefinedStringAddonVersionmay be undefinedstringAddonVersionmay be undefined*string#CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringrequiredstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsrequired#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*stringrequired#configurationValuesmay be undefinedstringconfiguration_valuesmay be undefinedstrconfigurationValuesmay be undefinedStringConfigurationValuesmay be undefinedstringConfigurationValuesmay be undefined*string#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*stringrequired#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
namespaceConfigmay be undefinedIResolvable | CfnAddon.NamespaceConfigPropertynamespace_configmay be undefinedtyping.Union[IResolvable, NamespaceConfigProperty]namespaceConfigmay be undefinedIResolvableNamespaceConfigmay be undefinedIResolvableNamespaceConfigmay be undefinedinterface{}#podIdentityAssociationsmay be undefinedIResolvable | IResolvable | CfnAddon.PodIdentityAssociationProperty[]pod_identity_associationsmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, PodIdentityAssociationProperty]]]podIdentityAssociationsmay be undefinedIResolvablePodIdentityAssociationsmay be undefinedIResolvablePodIdentityAssociationsmay be undefinedinterface{}#preserveOnDeletemay be undefinedboolean | IResolvablepreserve_on_deletemay be undefinedtyping.Union[bool, IResolvable]preserveOnDeletemay be undefinedBooleanPreserveOnDeletemay be undefinedboolPreserveOnDeletemay be undefinedinterface{}#If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
resolveConflictsmay be undefinedstringresolve_conflictsmay be undefinedstrresolveConflictsmay be undefinedStringResolveConflictsmay be undefinedstringResolveConflictsmay be undefined*string#serviceAccountRoleArnmay be undefinedstringservice_account_role_arnmay be undefinedstrserviceAccountRoleArnmay be undefinedStringServiceAccountRoleArnmay be undefinedstringServiceAccountRoleArnmay be undefined*string#CfnElements must be defined within a stack scope (directly or indirectly).
Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnAddon(x: any): boolean@staticmethod def is_cfn_addon(x: Any) -> boolpublic static Boolean isCfnAddon(Object x)public static bool IsCfnAddon(object x)func IsCfnAddon(X interface{}) *boolstatic#isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.